/*
 * @(#)%Name% %Version% %Time%
 * 
 * Copyright (c) 1997 Rutgers University
 *
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee,
 * provided that (i) the above copyright notice and this permission notice
 * appear in all copies of the software and related documentation. (ii) 
 * the name of Rutgers University may not be used in any advertising
 * or publicity relating to the software without the specific, prior
 * written permission of Rutgers University.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT SHALL RUTGERS UNIVERSITY BE LIABLE FOR ANY SPECIAL,
 * INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY
 * DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY
 * THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE
 * OR PERFORMANCE OF THIS SOFTWARE.
 * 
 * CopyrightVersion %Version%
 * @author		%Author%
 * @version		%Version%, %Time%
 * @since		ACT %Version%
 *
 0*/

package ORG.omg.CORBA;

import EDU.rutgers.act.presentation.TypeReader;
import EDU.rutgers.act.presentation.TypeWriter;

/**
 * [CORBA 2.0 Specification 12-14]
 *
 * @since ACT 0.1
 */
public final class Principal implements Streamable
{
    /**
     * No standard format, use sequence<octet> instead.
     *
     * @see OctetSequence
     *
     * @since ACT 0.1
     */
    private byte[] values_;

    /**
     * Used by Streamable
     *
     * @see Streamable
     *
     * @since ACT 0.1
     */
    public Principal() {
    }

    public Principal(byte[] v) {
		values_ = v;
    }

    /**
     * Retrieve the byte array representation of Principle
     *
     * @since ACT 0.1
     */
    public byte[] values() {
		return values_;
    }

    /**
     * @see Streamable
     * @see Streamable#read
     *
     * @since ACT 0.1
     */
    public void read(TypeReader in) 
		throws java.io.IOException {
		int len = in.readLong();
		values_ = new byte[len];
		in.readOctetArray(values_, 0, len);
	}

    /**
     * @see Streamable
     * @see Streamable#write
     *
     * @since ACT 0.1
     */
    public void write(TypeWriter out)
		throws java.io.IOException {
		int len = values_.length;
		out.writeLong(len);
		out.writeOctetArray(values_, 0, len);
	}

// Object
/*
    public boolean equals(Object o) {
		if((o != null) && (o instanceof Principal)) {
			Principal p = (Principal)o;
            String s1 = new String(values_);
            String s2 = new String(p.values());
            return s1.equals(s2);
		}	
		return false;
    }
*/

    /**
     * Returns a string representation.
     *
     * @return String description
     *
     * @since ACT 0.1
     */
    public String toString() {
        return "CORBA::Principal " + (new OctetSequence(values_));
    }
}
